#include <stdio.h>
#include <math.h>

#include <sp/spLib.h>

#define FFT_ORDER 10
#define SIN_NCYCLE 5

int main(int argc, char **argv)
{
    long fftl;
    spDVector x, y;
    spDVector win;
    spFFTRec fftrec;

    fftrec = spInitFFT(FFT_ORDER, SP_FFT_DEFAULT_PRECISION);
    fftl = spGetFFTLength(fftrec);

    x = xdvinit(0, 1, fftl - 1);
    dvscoper(x, "*", 2.0 * PI * SIN_NCYCLE / (double)(fftl - 1));
    dvsin(x);
#if 1
    win = xdvhamming(x->length);
    dvoper(x, "*", win);
    xdvfree(win);
#endif

    y = xdvfftex(fftrec, x);
#if 1
    dvabs(y);
#endif
    dvdump(y);

    xdvfree(x);
    xdvfree(y);
    
    spFreeFFT(fftrec);
    
    return 0;
}
